// last time modified by Igor UA3DJY on 20200205
// -*- Mode: C++ -*-

#ifndef LogQSO_H
#define LogQSO_H

#ifdef QT5
#include <QtWidgets>
#else
#include <QtGui>
#endif

#include <QScopedPointer>
#include "Radio.hpp"

#include "logbook/logbook.h"  //ja2bqx

namespace Ui {
  class LogQSO;
}

class QSettings;
class Configuration;

class LogQSO : public QDialog
{
  Q_OBJECT

public:
  explicit LogQSO(QSettings *, Configuration const *, QWidget *parent = 0);
  ~LogQSO();
  void initLogQSO(QString const& hisCall, QString const& hisGrid, QString mode,
                  QString const& rptSent, QString const& rptRcvd, QString const& name, QDateTime const& dateTimeOn,
                  QDateTime const& dateTimeOff, Radio::Frequency dialFreq, bool autologging);
                  

  // -----> ja2bqx

QString searchPrefix;
QString jtdxEntity;
QString thwCode;
QString thwEntityName;
QString entity_name;
QString search_call_str;
QString check_call;
QString countryName;
QString Qsl_Mark_str;

QString  ary_searchPrefix[1010];
QString  ary_jtdxEntity[1010];

int len;
int ffp;
int ffp0;
int ffp1;
int ffp2;
int ffp3;
int ffp4;
int ffp5;

//void init_getDXCC();
void get_thwCode_from_jtdxEntity ();

void get_entity_from_Unique_callsign_Suuji ();
void get_entity_from_Unique_callsign_ABCDEF ();
void get_entity_from_Unique_callsign_GHIJ ();
void get_entity_from_Unique_callsign_K ();
void get_entity_from_Unique_callsign_LMN ();
void get_entity_from_Unique_callsign_OPQRSTUV ();
void get_entity_from_Unique_callsign_WXYZ ();

void get_thw_qsl_mark();
void put_thw_qsl_mark();

QString fname;
int sd;
      // <----- ja2bqx

public slots:
  void accept();

signals:
  void acceptQSO (QDateTime const& QSO_date_off, QString const& call, QString const& grid
                  , Radio::Frequency dial_freq, QString const& mode
                  , QString const& rpt_sent, QString const& rpt_received
                  , QString const& tx_power, QString const& comments
                  , QString const& name, QDateTime const& QSO_date_on
                  , QString const& eqslcomments, QByteArray const& myadif2);

protected:
  void hideEvent (QHideEvent *);

private:
  void loadSettings ();
  void storeSettings () const;

  QScopedPointer<Ui::LogQSO> ui;
  QSettings * m_settings;
  Configuration const * m_config;
  QString m_txPower;
  QString m_comments;
  QString m_eqslcomments;
  Radio::Frequency m_dialFreq;
  QString m_myCall;
  QString m_myGrid;
  QDateTime m_dateTimeOn;
  QDateTime m_dateTimeOff;
  bool m_send_to_eqsl;
  bool m_send_to_hamlog;  //ja2bqx
  QString m_HamlogHdb_path;  //ja2bqx
  QString m_eqsl_username;
  QString m_eqsl_passwd;
  QString m_eqsl_nickname;
  QString m_tcp_server_name;
  uint m_tcp_server_port;
  uint m_eqsltimer;
  bool m_enable_tcp_connection;
  bool m_debug;
};

#endif // LogQSO_H
